


--this function is called already in game. This gives us a hook to screw the 
--blueprint values for the units

do
    local oldModBlueprints = ModBlueprints

    function ModBlueprints(all_bps)
	    oldModBlueprints(all_bps)

--        percentage_cost = 0.01
        percentage_cost = 0.05
--        percentage_cost = 0.1
        
        --loop through the blueprints and adjust as desired.
        for id,bp in all_bps.Unit do
            #check the blueprint if this unit is an economic category (like an energy producer or storage unit).
            #first check if it produces energy (cause a support commander isnt categorized as economic)

            local isEconomicUnit = (bp.Economy.ProductionPerSecondEnergy > 0)
            local isBuilder = false
            local isSubCommander = false

            local isStructure = false
            local isShield = false
            local isIntelligence = false
            local isSilo = false

            for k,v in bp.Categories do
                if ( v == 'ECONOMIC') then
                    isEconomicUnit = true
                end
                if ( v =='FACTORY') or (v == 'ENGINEER') then
                    isBuilder = true
                end

                if (v == 'SUBCOMMANDER') then
                    isSubCommander = true
                end

                if (v == 'SHIELD') then
                    isShield = true
                end

                if (v == 'STRUCTURE') then
                    isStructure = true
                end

                if (v == 'INTELLIGENCE') then
                    isIntelligence = true
                end

                if (v == 'SILO') then
                    isSilo = true
                end
            end

            if (isSubCommander) then
                #subcommanders are really more fighters than workers/energy gatherers so they are excepted.
                isEconomicUnit = false
                isBuilder = false
            end

            local isAlreadyEnergygobbling = false
            if (isStructure) then
                if (isIntelligence or isSilo or isShield) then
                    isAlreadyEnergygobbling = true
                end
            end


            if (not isEconomicUnit) and (not isBuilder) and (not isAlreadyEnergygobbling) then

              # this cost is a minumum cost for operating the unit
              local Ecost = bp.Economy.BuildCostEnergy
              # scale the cost
              Ecost = Ecost * percentage_cost
              bp.Economy.MinConsumptionPerSecondEnergy = Ecost
              bp.Economy.initialMaintenance = true

              #if there is an existing consumption (eg due to cloak), then add to it.
              # and otherwise define a fresh one.
              if (bp.Economy.MaintenanceConsumptionPerSecondEnergy) then
                  bp.Economy.MaintenanceConsumptionPerSecondEnergy = bp.Economy.MaintenanceConsumptionPerSecondEnergy + Ecost
              else
                  bp.Economy.MaintenanceConsumptionPerSecondEnergy = Ecost
              end

              #add a pause option... and make this known as well to the modscript...
              bp.General.CanDisableUnit = false
              if ((not bp.General.CommandCaps.RULEUCC_Pause)  or  (bp.General.CommandCaps.RULEUCC_Pause != true)) then
                   bp.General.CommandCaps.RULEUCC_Pause = true
                   bp.General.CanDisableUnit = true
              end

            end
    
            # make enhancements (for commanders) less useful cause they are too hard to kill ;)
            if bp.Enhancements.ResourceAllocation then
              local fraction = 0.2
              local res = bp.Enhancements.ResourceAllocation 
              res.ProductionPerSecondEnergy = fraction * res.ProductionPerSecondEnergy
              res.ProductionPerSecondMass = fraction * res.ProductionPerSecondMass
              res.BuildCostEnergy = fraction * res.BuildCostEnergy
              res.BuildCostMass = fraction * res.BuildCostMass
              res.BuildTime = fraction * res.BuildTime
            end

        end

    end

end




